con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
  '_xinfreq = 20_000_000                                       

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con 

  #(-1), IS_ON, IS_OFF

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS
 
CON
       M1_PWM = 9
       M1_DIR = 10
       M1_EN  = 8

       M2_PWM = 12
       M2_DIR = 13
       M2_EN  = 11   
        
       SPEED = 100
       SP80 = 80
       STOP = 0 

       MOTOR1 = 0
       MOTOR2 = 1
        
OBJ
        drive_motor12 : "motor_pwm"

VAR     Byte Second_trip
        Long Stack1[30]
        Long Stack2[30]
        Long Stack3[30]
        Long Stack4[30]

        Long Pos[2]                                  'encoder stack (one encoder, one delta)

        Long cog1fwd
        Long cog1bck
        Long cog2fwd
        Long cog2bck


PUB init(reconstructed_data, Motor_Ident)   | ok1bck , ok1fwd , ok2bck, ok2fwd

IF Second_trip == 0
  Drive_motor12.Start(M1_PWM, M1_DIR, M2_PWM, M2_DIR, 2_500)
  high(M1_EN)
  high(M2_EN)
 
Second_trip := 1     

{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

IF(reconstructed_data < 30)  AND  (Motor_Ident == 1)
  if cog1fwd                                                                    'if the motor is motoring fwd
    Drive_motor12.SetSpeed(MOTOR1, STOP)                                  'set speed to zero, stop cog
    cogstop(cog1fwd~ -1)
  ok1fwd := (cog1fwd := cognew(Motor_fwd1(reconstructed_data),@Stack1) + 1)
  return cog1fwd 
                                    '
IF(reconstructed_data > 30)  AND  (Motor_Ident == 1)
  if cog1bck                                                                      'if the motor is motoring fwd
    Drive_motor12.SetSpeed(MOTOR1, STOP)                                  'set speed to zero, stop cog
    cogstop(cog1bck~ -1)
  ok1bck := (cog1bck := cognew(Motor_bck1(reconstructed_data),@Stack2) + 1)
  return cog1bck   

{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

IF(reconstructed_data < 30)  AND  (Motor_Ident == 2)
  if cog2fwd                                                                    'if the motor is motoring fwd
    Drive_motor12.SetSpeed(MOTOR2, STOP)                                  'set speed to zero, stop cog
    cogstop(cog2fwd~ -1)
  ok2fwd := (cog2fwd := cognew(Motor_fwd2(reconstructed_data),@Stack3) + 1)
  return cog2fwd 
                                    '
IF(reconstructed_data > 30)  AND  (Motor_Ident == 2)
  if cog2bck                                                                      'if the motor is motoring fwd
    Drive_motor12.SetSpeed(MOTOR2, STOP)                                  'set speed to zero, stop cog
    cogstop(cog2bck~ -1)
  ok2bck := (cog2bck := cognew(Motor_bck2(reconstructed_data),@Stack4) + 1)
  return cog2bck

{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

PUB motor_bck1(reconstructed_Data) '| rotation, Delta1
                                                                     
if cog1fwd
   Drive_motor12.SetSpeed(MOTOR1, STOP)
   cogstop(cog1fwd~ -1)

repeat                                
  Drive_motor12.SetSpeed(MOTOR1, -SPEED)

return

PUB motor_fwd1(reconstructed_Data) '| rotation, Delta1

if cog1bck                                                                      'if the motor is motoring fwd
   Drive_motor12.SetSpeed(MOTOR1, STOP)                                   'set speed to zero, stop cog
  cogstop(cog1bck~ -1)
 
repeat
  Drive_motor12.SetSpeed(MOTOR1, SPEED)                                      'turn motor fwd

return                  
                                      

PUB motor_bck2(reconstructed_Data) | rotation, Delta1

if cog2fwd                                                              
  Drive_motor12.SetSpeed(MOTOR2, STOP)
  cogstop(cog2fwd~ -1)

repeat
  Drive_motor12.SetSpeed(MOTOR2, -SPEED)     
RETURN


PUB motor_fwd2(reconstructed_Data) | rotation, Delta1

if cog2bck                                                              'if motor1 is motoring fwd
  Drive_motor12.SetSpeed(MOTOR2, STOP)                                    'set speed to zero, stop cog
  cogstop(cog2bck~ -1)

repeat
  Drive_motor12.SetSpeed(MOTOR2, SPEED)                             'set motor speed fwd
   
PUB pause(ms) | t                                                        '{+->dir=0; pwm ^v^}  
 t := cnt - 1088
   repeat (ms #> 0)
    waitcnt(t += MS_001)

pub high(pin)

outa[pin] := 1
dira[pin] := 1                                                     

pub low(pin)

outa[pin] := 0
dira[pin] := 1

pub input(pin)

dira[pin] := 0

return ina[pin]








  